import { InternError } from '../types';
import { Executor } from '../executors/Executor';
export default class ErrorFormatter implements ErrorFormatterProperties {
    readonly executor: Executor;
    constructor(executor: Executor);
    format(error: string | Error | InternError, options?: ErrorFormatOptions): string;
    protected _getSource(tracepath: string): string;
    protected _createDiff(actual: string, expected: string): string;
    protected _createDiff(actual: object, expected: object): string;
    protected _formatLine(data: {
        func?: string;
        source: string;
    }): string;
    protected _normalizeStackTrace(stack: string): string;
    protected _processChromeTrace(lines: string[]): string[];
    protected _processSafariTrace(lines: string[]): string[];
}
export interface ErrorFormatterProperties {
    executor: Executor;
}
export interface ErrorFormatOptions {
    space?: string;
}
