(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "http"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var http_1 = require("http");
    function finalError() {
        return function (error, request, response, _) {
            var message = error.expose
                ? error.message
                : http_1.STATUS_CODES[error.statusCode];
            response.writeHead(error.statusCode, {
                'Content-Type': 'text/html;charset=utf-8'
            });
            response.end("<!DOCTYPE html><title>" + error.statusCode + " " + message + "</title><h1>" + error.statusCode + " " + message + ": " + request.url + "</h1>\n<!-- " + new Array(512).join('.') + " -->");
        };
    }
    exports.default = finalError;
});
//# sourceMappingURL=finalError.js.map