import { Executor } from '../executors/Executor';
import Reporter, { ReporterProperties } from './Reporter';
import Suite from '../Suite';
import Test from '../Test';
export default class Dom extends Reporter {
    document: HTMLDocument;
    suiteNode: HTMLElement;
    testNode: HTMLElement | undefined;
    constructor(executor: Executor, options?: DomOptions);
    error(error: Error): void;
    suiteEnd(suite: Suite): void;
    suiteStart(suite: Suite): void;
    testEnd(test: Test): void;
    testStart(test: Test): void;
    private _scroll;
}
export interface DomProperties extends ReporterProperties {
    document: Document;
    suiteNode: HTMLElement;
}
export declare type DomOptions = Partial<DomProperties>;
