(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "./Coverage"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Coverage_1 = require("./Coverage");
    var TextCoverage = (function (_super) {
        tslib_1.__extends(TextCoverage, _super);
        function TextCoverage(executor, options) {
            if (options === void 0) { options = {}; }
            var _this = _super.call(this, executor, options) || this;
            _this.reportType = 'text';
            if (options.maxColumns) {
                _this.maxColumns = options.maxColumns;
            }
            return _this;
        }
        TextCoverage.prototype.getReporterOptions = function () {
            var options = _super.prototype.getReporterOptions.call(this);
            options.maxColumns = this.maxColumns;
            return options;
        };
        return TextCoverage;
    }(Coverage_1.default));
    exports.default = TextCoverage;
});
//# sourceMappingURL=TextCoverage.js.map