"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
intern.registerLoader(function (options) {
    var globalObj = typeof window !== 'undefined' ? window : global;
    options.baseUrl = options.baseUrl || intern.config.basePath;
    if (!('async' in options)) {
        options.async = true;
    }
    options.has = __assign({ 'dojo-timeout-api': true }, options.has);
    intern.log('Configuring Dojo loader with:', options);
    globalObj.dojoConfig = options;
    return intern.loadScript('node_modules/dojo/dojo.js').then(function () {
        var require = globalObj.require;
        intern.log('Using Dojo loader');
        return function (modules) {
            var handle;
            return new Promise(function (resolve, reject) {
                handle = require.on('error', function (error) {
                    intern.emit('error', error);
                    reject(new Error("Dojo loader error: " + error.message));
                });
                intern.log('Loading modules:', modules);
                require(modules, function () {
                    resolve();
                });
            }).then(function () {
                handle.remove();
            }, function (error) {
                handle && handle.remove();
                throw error;
            });
        };
    });
});
//# sourceMappingURL=dojo.js.map